/////////////////////////////////////////////////////////////////////////////////
//
// DecryptListener.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: DecryptListener.cpp,v $
 * Revision 1.2  2000/07/15 02:09:55  syou
 * - PGP/MIMEÍƏꂽ[̏؂Bclass
 *   CDecryptListenerclass CSignatureListenerhAPGP/MIME
 *   ꂽ[̏؂ƁA\[`LBƂ
 *   CɂȂ̂͂2̃NX̖OAPGPEventtׂH
 *
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */


#include <windows.h>
#include "DecryptListener.h"


/////////////////////////////////////////////////////////////////////////////////
//
CDecryptListener::CDecryptListener()
{
    CSignatureListener::CSignatureListener();
    hWnd = NULL;
}


CDecryptListener::~CDecryptListener()
{
}


void CDecryptListener::SetWindowHandle(HWND newHWnd)
{
    hWnd = newHWnd;
}


HWND CDecryptListener::GetWindowHandle() const
{
    return hWnd;
}


PGPError CDecryptListener::InputPassphrase(PGPContextRef context, PGPEvent* event)
{
    PGPError err = PGPsdkUILibInit();
    if (IsPGPError(err)) {
        return kPGPError_UserAbort;
    }

    PGPEventPassphraseData *d = &event->data.passphraseData;
    LPSTR lpPassphrase = NULL;
    if (d->fConventional) {
        err = PGPConventionalDecryptionPassphraseDialog(
                context,
                PGPOUIOutputPassphrase(context, &lpPassphrase),
                PGPOUIParentWindowHandle(context, GetWindowHandle()),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOLastOption(context)
                );
    }
    else {
        PGPKeyID keyIDList[1];
        PGPKeyRef decryptionKey;
        err = PGPDecryptionPassphraseDialog(
                context,
                d->keyset,
                0,
                keyIDList,
                &decryptionKey,
                PGPOUIOutputPassphrase(context, &lpPassphrase),
                PGPOUIParentWindowHandle(context, GetWindowHandle()),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOLastOption(context)
                );
    }

    if (IsPGPError(err)) {
        PGPsdkUILibCleanup();
        return kPGPError_UserAbort;
    }

    err = PGPAddJobOptions(event->job,
        PGPOPassphraseBuffer(context, lpPassphrase, strlen(lpPassphrase)),
        PGPOLastOption(context)
        );

    PGPFreeData(lpPassphrase);
    PGPsdkUILibCleanup();

    if (IsPGPError(err)) {
        return kPGPError_UserAbort;
    }

    return kPGPError_NoErr;
}


PGPError CDecryptListener::ListenEvent(PGPContextRef context, PGPEvent* event)
{
    PGPError err = kPGPError_NoErr;
    switch(event->type)
    {
    case kPGPEvent_PassphraseEvent:
        err = InputPassphrase(context, event);
        break;
    default:
        err = CSignatureListener::ListenEvent(context, event);
        break;
    }

    return err;
}
